--- /dev/null	2012-06-12 19:55:06.000000000 +0200
+++ new/usr/src/lib/libdladm/common/wpa_if.c	2012-06-12 19:55:06.332444980 +0200
@@ -0,0 +1,821 @@
+/*
+ * Copyright (c) 2002-2012, Jouni Malinen <j@w1.fi>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * Alternatively, this software may be distributed under the terms of BSD
+ * license.
+ */
+
+#include <unistd.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <strings.h>
+#include <errno.h>
+#include <ctype.h>
+#include <fcntl.h>
+#include <sys/socket.h>
+#include <libdlwlan.h>
+
+#define WPA_CTRL_RSP "CTRL-RSP-"
+
+enum wpa_cmd_flags {
+	cli_cmd_flag_none	= 0x00,
+	cli_cmd_flag_sensitive	= 0x01
+};
+
+struct wpa_cmd {
+	const char *cmd;
+	int (*handler)(struct wpa_ctrl *ctrl, int argc, char *argv[]);
+	enum wpa_cmd_flags flags;
+	const char *usage;
+};
+
+/**
+ * wpa_ctrl_request - Send a command to wpa_supplicant/hostapd
+ * @ctrl: Control interface data from wpa_ctrl_open()
+ * @cmd: Command; usually, ASCII text, e.g., "PING"
+ * @cmd_len: Length of the cmd in bytes
+ * @reply: Buffer for the response
+ * @reply_len: Reply buffer length
+ * @msg_cb: Callback function for unsolicited messages or %NULL if not used
+ * Returns: 0 on success, -1 on error (send or receive failed), -2 on timeout
+ *
+ * This function is used to send commands to wpa_supplicant/hostapd. Received
+ * response will be written to reply and reply_len is set to the actual length
+ * of the reply. This function will block for up to two seconds while waiting
+ * for the reply. If unsolicited messages are received, the blocking time may
+ * be longer.
+ *
+ * msg_cb can be used to register a callback function that will be called for
+ * unsolicited messages received while waiting for the command response. These
+ * messages may be received if wpa_ctrl_request() is called at the same time as
+ * wpa_supplicant/hostapd is sending such a message. This can happen only if
+ * the program has used wpa_ctrl_attach() to register itself as a monitor for
+ * event messages. Alternatively to msg_cb, programs can register two control
+ * interface connections and use one of them for commands and the other one for
+ * receiving event messages, in other words, call wpa_ctrl_attach() only for
+ * the control interface connection that will be used for event messages.
+ */
+static int wpa_ctrl_request(struct wpa_ctrl *ctrl, const char *cmd,
+    size_t cmd_len, char *reply, size_t *reply_len,
+    void (*msg_cb)(char *msg, size_t len));
+
+/* These are temporary UNIX sockets created for receiving requests messages*/
+#define CTRL_IFACE_CLIENT_DIR "/var/run"
+#define CTRL_IFACE_CLIENT_PREFIX "wpa_ctrl_"
+
+struct wpa_ctrl * wpa_ctrl_open(const char *ctrl_path)
+{
+	struct wpa_ctrl *ctrl;
+	static int counter = 0;
+	int ret;
+	size_t res;
+	int tries = 0;
+
+	ctrl = malloc(sizeof(*ctrl));
+	if (ctrl == NULL)
+		return NULL;
+	memset(ctrl, 0, sizeof(*ctrl));
+
+	ctrl->s = socket(PF_UNIX, SOCK_DGRAM, 0);
+	if (ctrl->s < 0) {
+		free(ctrl);
+		return NULL;
+	}
+
+	ctrl->local.sun_family = AF_UNIX;
+	counter++;
+try_again:
+	ret = snprintf(ctrl->local.sun_path, sizeof(ctrl->local.sun_path),
+	    CTRL_IFACE_CLIENT_DIR "/"
+	    CTRL_IFACE_CLIENT_PREFIX "%d-%d", (int) getpid(), counter);
+	if (ret < 0 || (size_t) ret >= sizeof(ctrl->local.sun_path)) {
+		close(ctrl->s);
+		free(ctrl);
+		return NULL;
+	}
+	tries++;
+	if (bind(ctrl->s, (struct sockaddr *) &ctrl->local,
+	    sizeof(ctrl->local)) < 0) {
+		if (errno == EADDRINUSE && tries < 2) {
+			/*
+			 * getpid() returns unique identifier for this instance
+			 * of wpa_ctrl, so the existing socket file must have
+			 * been left by unclean termination of an earlier run.
+			 * Remove the file and try again.
+			 */
+			unlink(ctrl->local.sun_path);
+			goto try_again;
+		}
+		close(ctrl->s);
+		free(ctrl);
+		return NULL;
+	}
+
+	ctrl->dest.sun_family = AF_UNIX;
+	res = strlcpy(ctrl->dest.sun_path, ctrl_path,
+			 sizeof(ctrl->dest.sun_path));
+	if (res >= sizeof(ctrl->dest.sun_path)) {
+		close(ctrl->s);
+		free(ctrl);
+		return NULL;
+	}
+	if (connect(ctrl->s, (struct sockaddr *) &ctrl->dest,
+		    sizeof(ctrl->dest)) < 0) {
+		close(ctrl->s);
+		unlink(ctrl->local.sun_path);
+		free(ctrl);
+		return NULL;
+	}
+
+	return ctrl;
+}
+
+void wpa_ctrl_close(struct wpa_ctrl *ctrl)
+{
+	if (ctrl == NULL)
+		return;
+	unlink(ctrl->local.sun_path);
+	if (ctrl->s >= 0)
+		close(ctrl->s);
+	free(ctrl);
+}
+
+static int wpa_ctrl_request(struct wpa_ctrl *ctrl, const char *cmd, size_t cmd_len,
+		     char *reply, size_t *reply_len,
+		     void (*msg_cb)(char *msg, size_t len))
+{
+	struct timeval tv;
+	int res;
+	fd_set rfds;
+	const char *_cmd;
+	char *cmd_buf = NULL;
+	size_t _cmd_len;
+
+	{
+		_cmd = cmd;
+		_cmd_len = cmd_len;
+	}
+
+	if (send(ctrl->s, _cmd, _cmd_len, 0) < 0) {
+		free(cmd_buf);
+		return -1;
+	}
+	free(cmd_buf);
+
+	for (;;) {
+		tv.tv_sec = 10;
+		tv.tv_usec = 0;
+		FD_ZERO(&rfds);
+		FD_SET(ctrl->s, &rfds);
+		res = select(ctrl->s + 1, &rfds, NULL, NULL, &tv);
+		if (res < 0)
+			return res;
+		if (FD_ISSET(ctrl->s, &rfds)) {
+			res = recv(ctrl->s, reply, *reply_len, 0);
+			if (res < 0)
+				return res;
+			if (res > 0 && reply[0] == '<') {
+				/* This is an unsolicited message from
+				 * wpa_supplicant, not the reply to the
+				 * request. Use msg_cb to report this to the
+				 * caller. */
+				if (msg_cb) {
+					/* Make sure the message is nul
+					 * terminated. */
+					if ((size_t) res == *reply_len)
+						res = (*reply_len) - 1;
+					reply[res] = '\0';
+					msg_cb(reply, res);
+				}
+				continue;
+			}
+			*reply_len = res;
+			break;
+		} else {
+			return -2;
+		}
+	}
+	return 0;
+}
+
+static void wpa_msg_cb(char *msg, size_t len)
+{
+	snprintf(msg, len, "%s\n");
+}
+
+static int _wpa_ctrl_command(struct wpa_ctrl *ctrl, char *cmd, int print)
+{
+	char buf[2048];
+	size_t len;
+	int ret;
+
+	len = sizeof(buf) - 1;
+	ret = wpa_ctrl_request(ctrl, cmd, strlen(cmd), buf, &len,
+			       wpa_msg_cb);
+	if (ret == -2) {
+		printf("'%s' command timed out.\n", cmd);
+		return -2;
+	} else if (ret < 0) {
+		printf("'%s' command failed.\n", cmd);
+		return -1;
+	}
+	if (print) {
+		buf[len] = '\0';
+		printf("%s", buf);
+	}
+	return 0;
+}
+
+static int wpa_ctrl_command(struct wpa_ctrl *ctrl, char *cmd)
+{
+	return _wpa_ctrl_command(ctrl, cmd, 1);
+}
+
+/* control interface commands routines */
+
+static int wpa_cmd_level(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	char cmd[256];
+	int res;
+
+	if (argc != 1) {
+		printf("Invalid LEVEL command: needs one argument (debug "
+		       "level)\n");
+		return -1;
+	}
+	res = snprintf(cmd, sizeof(cmd), "LEVEL %s", argv[0]);
+	if (res < 0 || (size_t) res >= sizeof(cmd) - 1) {
+		printf("Too long LEVEL command.\n");
+		return -1;
+	}
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_reassociate(struct wpa_ctrl *ctrl, int argc,
+				   char *argv[])
+{
+	return wpa_ctrl_command(ctrl, "REASSOCIATE");
+}
+
+static int wpa_cmd_identity(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	char cmd[256], *pos, *end;
+	int i, ret;
+
+	if (argc < 2) {
+		printf("Invalid IDENTITY command: needs two arguments "
+		       "(network id and identity)\n");
+		return -1;
+	}
+
+	end = cmd + sizeof(cmd);
+	pos = cmd;
+	ret = snprintf(pos, end - pos, WPA_CTRL_RSP "IDENTITY-%s:%s",
+			  argv[0], argv[1]);
+	if (ret < 0 || ret >= end - pos) {
+		printf("Too long IDENTITY command.\n");
+		return -1;
+	}
+	pos += ret;
+	for (i = 2; i < argc; i++) {
+		ret = snprintf(pos, end - pos, " %s", argv[i]);
+		if (ret < 0 || ret >= end - pos) {
+			printf("Too long IDENTITY command.\n");
+			return -1;
+		}
+		pos += ret;
+	}
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_password(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	char cmd[256], *pos, *end;
+	int i, ret;
+
+	if (argc < 2) {
+		printf("Invalid PASSWORD command: needs two arguments "
+		       "(network id and password)\n");
+		return -1;
+	}
+
+	end = cmd + sizeof(cmd);
+	pos = cmd;
+	ret = snprintf(pos, end - pos, WPA_CTRL_RSP "PASSWORD-%s:%s",
+			  argv[0], argv[1]);
+	if (ret < 0 || ret >= end - pos) {
+		printf("Too long PASSWORD command.\n");
+		return -1;
+	}
+	pos += ret;
+	for (i = 2; i < argc; i++) {
+		ret = snprintf(pos, end - pos, " %s", argv[i]);
+		if (ret < 0 || ret >= end - pos) {
+			printf("Too long PASSWORD command.\n");
+			return -1;
+		}
+		pos += ret;
+	}
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_new_password(struct wpa_ctrl *ctrl, int argc,
+				    char *argv[])
+{
+	char cmd[256], *pos, *end;
+	int i, ret;
+
+	if (argc < 2) {
+		printf("Invalid NEW_PASSWORD command: needs two arguments "
+		       "(network id and password)\n");
+		return -1;
+	}
+
+	end = cmd + sizeof(cmd);
+	pos = cmd;
+	ret = snprintf(pos, end - pos, WPA_CTRL_RSP "NEW_PASSWORD-%s:%s",
+			  argv[0], argv[1]);
+	if (ret < 0 || ret >= end - pos) {
+		printf("Too long NEW_PASSWORD command.\n");
+		return -1;
+	}
+	pos += ret;
+	for (i = 2; i < argc; i++) {
+		ret = snprintf(pos, end - pos, " %s", argv[i]);
+		if (ret < 0 || ret >= end - pos) {
+			printf("Too long NEW_PASSWORD command.\n");
+			return -1;
+		}
+		pos += ret;
+	}
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+
+static int wpa_cmd_pin(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	char cmd[256], *pos, *end;
+	int i, ret;
+
+	if (argc < 2) {
+		printf("Invalid PIN command: needs two arguments "
+		       "(network id and pin)\n");
+		return -1;
+	}
+
+	end = cmd + sizeof(cmd);
+	pos = cmd;
+	ret = snprintf(pos, end - pos, WPA_CTRL_RSP "PIN-%s:%s",
+			  argv[0], argv[1]);
+	if (ret < 0 || ret >= end - pos) {
+		printf("Too long PIN command.\n");
+		return -1;
+	}
+	pos += ret;
+	for (i = 2; i < argc; i++) {
+		ret = snprintf(pos, end - pos, " %s", argv[i]);
+		if (ret < 0 || ret >= end - pos) {
+			printf("Too long PIN command.\n");
+			return -1;
+		}
+		pos += ret;
+	}
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_passphrase(struct wpa_ctrl *ctrl, int argc,
+				  char *argv[])
+{
+	char cmd[256], *pos, *end;
+	int i, ret;
+
+	if (argc < 2) {
+		printf("Invalid PASSPHRASE command: needs two arguments "
+		       "(network id and passphrase)\n");
+		return -1;
+	}
+
+	end = cmd + sizeof(cmd);
+	pos = cmd;
+	ret = snprintf(pos, end - pos, WPA_CTRL_RSP "PASSPHRASE-%s:%s",
+			  argv[0], argv[1]);
+	if (ret < 0 || ret >= end - pos) {
+		printf("Too long PASSPHRASE command.\n");
+		return -1;
+	}
+	pos += ret;
+	for (i = 2; i < argc; i++) {
+		ret = snprintf(pos, end - pos, " %s", argv[i]);
+		if (ret < 0 || ret >= end - pos) {
+			printf("Too long PASSPHRASE command.\n");
+			return -1;
+		}
+		pos += ret;
+	}
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+
+static int wpa_cmd_bssid(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	char cmd[256], *pos, *end;
+	int i, ret;
+
+	if (argc < 2) {
+		printf("Invalid BSSID command: needs two arguments (network "
+		       "id and BSSID)\n");
+		return -1;
+	}
+
+	end = cmd + sizeof(cmd);
+	pos = cmd;
+	ret = snprintf(pos, end - pos, "BSSID");
+	if (ret < 0 || ret >= end - pos) {
+		printf("Too long BSSID command.\n");
+		return -1;
+	}
+	pos += ret;
+	for (i = 0; i < argc; i++) {
+		ret = snprintf(pos, end - pos, " %s", argv[i]);
+		if (ret < 0 || ret >= end - pos) {
+			printf("Too long BSSID command.\n");
+			return -1;
+		}
+		pos += ret;
+	}
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_log_level(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	char cmd[256], *pos, *end;
+	int i, ret;
+
+	end = cmd + sizeof(cmd);
+	pos = cmd;
+	ret = snprintf(pos, end - pos, "LOG_LEVEL");
+	if (ret < 0 || ret >= end - pos) {
+		printf("Too long LOG_LEVEL command.\n");
+		return -1;
+	}
+	pos += ret;
+	for (i = 0; i < argc; i++) {
+		ret = snprintf(pos, end - pos, " %s", argv[i]);
+		if (ret < 0 || ret >= end - pos) {
+			printf("Too long LOG_LEVEL command.\n");
+			return -1;
+		}
+		pos += ret;
+	}
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_select_network(struct wpa_ctrl *ctrl, int argc,
+				      char *argv[])
+{
+	char cmd[32];
+	int res;
+
+	if (argc < 1) {
+		printf("Invalid SELECT_NETWORK command: needs one argument "
+		       "(network id)\n");
+		return -1;
+	}
+
+	res = snprintf(cmd, sizeof(cmd), "SELECT_NETWORK %s", argv[0]);
+	if (res < 0 || (size_t) res >= sizeof(cmd))
+		return -1;
+	cmd[sizeof(cmd) - 1] = '\0';
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+
+static int wpa_cmd_enable_network(struct wpa_ctrl *ctrl, int argc,
+				      char *argv[])
+{
+	char cmd[32];
+	int res;
+
+	if (argc < 1) {
+		printf("Invalid ENABLE_NETWORK command: needs one argument "
+		       "(network id)\n");
+		return -1;
+	}
+
+	res = snprintf(cmd, sizeof(cmd), "ENABLE_NETWORK %s", argv[0]);
+	if (res < 0 || (size_t) res >= sizeof(cmd))
+		return -1;
+	cmd[sizeof(cmd) - 1] = '\0';
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+
+static int wpa_cmd_disable_network(struct wpa_ctrl *ctrl, int argc,
+				       char *argv[])
+{
+	char cmd[32];
+	int res;
+
+	if (argc < 1) {
+		printf("Invalid DISABLE_NETWORK command: needs one argument "
+		       "(network id)\n");
+		return -1;
+	}
+
+	res = snprintf(cmd, sizeof(cmd), "DISABLE_NETWORK %s", argv[0]);
+	if (res < 0 || (size_t) res >= sizeof(cmd))
+		return -1;
+	cmd[sizeof(cmd) - 1] = '\0';
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+
+static int wpa_cmd_add_network(struct wpa_ctrl *ctrl, int argc,
+				   char *argv[])
+{
+	return wpa_ctrl_command(ctrl, "ADD_NETWORK");
+}
+
+
+static int wpa_cmd_remove_network(struct wpa_ctrl *ctrl, int argc,
+				      char *argv[])
+{
+	char cmd[32];
+	int res;
+
+	if (argc < 1) {
+		printf("Invalid REMOVE_NETWORK command: needs one argument "
+		       "(network id)\n");
+		return -1;
+	}
+
+	res = snprintf(cmd, sizeof(cmd), "REMOVE_NETWORK %s", argv[0]);
+	if (res < 0 || (size_t) res >= sizeof(cmd))
+		return -1;
+	cmd[sizeof(cmd) - 1] = '\0';
+
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_set_network(struct wpa_ctrl *ctrl, int argc,
+				   char *argv[])
+{
+	char cmd[256];
+	int res;
+
+	if (argc != 3) {
+		printf("Invalid SET_NETWORK command: needs three arguments\n"
+		       "(network id, variable name, and value)\n");
+		return -1;
+	}
+
+	res = snprintf(cmd, sizeof(cmd), "SET_NETWORK %s %s %s",
+			  argv[0], argv[1], argv[2]);
+	if (res < 0 || (size_t) res >= sizeof(cmd) - 1) {
+		printf("Too long SET_NETWORK command.\n");
+		return -1;
+	}
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_disconnect(struct wpa_ctrl *ctrl, int argc,
+				  char *argv[])
+{
+	return wpa_ctrl_command(ctrl, "DISCONNECT");
+}
+
+static int wpa_cmd_reconnect(struct wpa_ctrl *ctrl, int argc,
+				  char *argv[])
+{
+	return wpa_ctrl_command(ctrl, "RECONNECT");
+}
+
+static int wpa_cmd_scan(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	return wpa_ctrl_command(ctrl, "SCAN");
+}
+
+
+static int wpa_cmd_scan_results(struct wpa_ctrl *ctrl, int argc,
+				    char *argv[])
+{
+	return wpa_ctrl_command(ctrl, "SCAN_RESULTS");
+}
+
+static int wpa_cmd_terminate(struct wpa_ctrl *ctrl, int argc,
+				 char *argv[])
+{
+	return wpa_ctrl_command(ctrl, "TERMINATE");
+}
+
+static int wpa_cmd_interface_add(struct wpa_ctrl *ctrl, int argc,
+				     char *argv[])
+{
+	char cmd[256];
+	int res;
+
+	if (argc < 1) {
+		printf("Invalid INTERFACE_ADD command: needs at least one "
+		       "argument (interface name)\n"
+		       "All arguments: ifname confname driver ctrl_interface "
+		       "driver_param bridge_name\n");
+		return -1;
+	}
+
+	/*
+	 * INTERFACE_ADD <ifname>TAB<confname>TAB<driver>TAB<ctrl_interface>TAB
+	 * <driver_param>TAB<bridge_name>
+	 */
+	res = snprintf(cmd, sizeof(cmd),
+			  "INTERFACE_ADD %s\t%s\t%s\t%s\t%s\t%s",
+			  argv[0],
+			  argc > 1 ? argv[1] : "", argc > 2 ? argv[2] : "",
+			  argc > 3 ? argv[3] : "", argc > 4 ? argv[4] : "",
+			  argc > 5 ? argv[5] : "");
+	if (res < 0 || (size_t) res >= sizeof(cmd))
+		return -1;
+	cmd[sizeof(cmd) - 1] = '\0';
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+
+static int wpa_cmd_interface_remove(struct wpa_ctrl *ctrl, int argc,
+					char *argv[])
+{
+	char cmd[128];
+	int res;
+
+	if (argc != 1) {
+		printf("Invalid INTERFACE_REMOVE command: needs one argument "
+		       "(interface name)\n");
+		return -1;
+	}
+
+	res = snprintf(cmd, sizeof(cmd), "INTERFACE_REMOVE %s", argv[0]);
+	if (res < 0 || (size_t) res >= sizeof(cmd))
+		return -1;
+	cmd[sizeof(cmd) - 1] = '\0';
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_ap_scan(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	char cmd[256];
+	int res;
+
+	if (argc != 1) {
+		printf("Invalid AP_SCAN command: needs one argument (ap_scan "
+		       "value)\n");
+		return -1;
+	}
+	res = snprintf(cmd, sizeof(cmd), "AP_SCAN %s", argv[0]);
+	if (res < 0 || (size_t) res >= sizeof(cmd) - 1) {
+		printf("Too long AP_SCAN command.\n");
+		return -1;
+	}
+	return wpa_ctrl_command(ctrl, cmd);
+}
+
+static int wpa_cmd_suspend(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	return wpa_ctrl_command(ctrl, "SUSPEND");
+}
+
+static struct wpa_cmd wpa_commands[] = {
+	{ "level", wpa_cmd_level,
+	  cli_cmd_flag_none,
+	  "<debug level> = change debug level" },
+	{ "reassociate", wpa_cmd_reassociate,
+	  cli_cmd_flag_none,
+	  "= force reassociation" },
+	{ "identity", wpa_cmd_identity,
+	  cli_cmd_flag_none,
+	  "<network id> <identity> = configure identity for an SSID" },
+	{ "password", wpa_cmd_password,
+	  cli_cmd_flag_sensitive,
+	  "<network id> <password> = configure password for an SSID" },
+	{ "new_password", wpa_cmd_new_password,
+	  cli_cmd_flag_sensitive,
+	  "<network id> <password> = change password for an SSID" },
+	{ "pin", wpa_cmd_pin,
+	  cli_cmd_flag_sensitive,
+	  "<network id> <pin> = configure pin for an SSID" },
+	{ "passphrase", wpa_cmd_passphrase,
+	  cli_cmd_flag_sensitive,
+	  "<network id> <passphrase> = configure private key passphrase\n"
+	  "  for an SSID" },
+	{ "bssid", wpa_cmd_bssid,
+	  cli_cmd_flag_none,
+	  "<network id> <BSSID> = set preferred BSSID for an SSID" },
+	{ "log_level", wpa_cmd_log_level,
+	  cli_cmd_flag_none,
+	  "<level> [<timestamp>] = update the log level/timestamp\n"
+	  "log_level = display the current log level and log options" },
+	{ "select_network", wpa_cmd_select_network,
+	  cli_cmd_flag_none,
+	  "<network id> = select a network (disable others)" },
+	{ "enable_network", wpa_cmd_enable_network,
+	  cli_cmd_flag_none,
+	  "<network id> = enable a network" },
+	{ "disable_network", wpa_cmd_disable_network,
+	  cli_cmd_flag_none,
+	  "<network id> = disable a network" },
+	{ "add_network", wpa_cmd_add_network,
+	  cli_cmd_flag_none,
+	  "= add a network" },
+	{ "remove_network", wpa_cmd_remove_network,
+	  cli_cmd_flag_none,
+	  "<network id> = remove a network" },
+	{ "set_network", wpa_cmd_set_network,
+	  cli_cmd_flag_sensitive,
+	  "<network id> <variable> <value> = set network variables (shows\n"
+	  "  list of variables when run without arguments)" },
+	{ "disconnect", wpa_cmd_disconnect,
+	  cli_cmd_flag_none,
+	  "= disconnect and wait for reassociate/reconnect command before\n"
+	  "  connecting" },
+	{ "reconnect", wpa_cmd_reconnect,
+	  cli_cmd_flag_none,
+	  "= like reassociate, but only takes effect if already disconnected"
+	},
+	{ "scan", wpa_cmd_scan,
+	  cli_cmd_flag_none,
+	  "= request new BSS scan" },
+	{ "scan_results", wpa_cmd_scan_results,
+	  cli_cmd_flag_none,
+	  "= get latest scan results" },
+	{ "terminate", wpa_cmd_terminate,
+	  cli_cmd_flag_none,
+	  "= terminate wpa_supplicant" },
+	{ "interface_add", wpa_cmd_interface_add,
+	  cli_cmd_flag_none,
+	  "<ifname> <confname> <driver> <ctrl_interface> <driver_param>\n"
+	  "  <bridge_name> = adds new interface, all parameters but <ifname>\n"
+	  "  are optional" },
+	{ "interface_remove", wpa_cmd_interface_remove,
+	  cli_cmd_flag_none,
+	  "<ifname> = removes the interface" },
+	{ "ap_scan", wpa_cmd_ap_scan,
+	  cli_cmd_flag_none,
+	  "<value> = set ap_scan parameter" },
+	{ "suspend", wpa_cmd_suspend, cli_cmd_flag_none,
+	  "= notification of suspend/hibernate" },
+	{ NULL, NULL, cli_cmd_flag_none, NULL }
+};
+
+int wpa_request(struct wpa_ctrl *ctrl, int argc, char *argv[])
+{
+	struct wpa_cmd *cmd, *match = NULL;
+	int count;
+	int ret = 0;
+
+	count = 0;
+	cmd = wpa_commands;
+	while (cmd->cmd) {
+		if (strncasecmp(cmd->cmd, argv[0], strlen(argv[0])) == 0)
+		{
+			match = cmd;
+			if (strcasecmp(cmd->cmd, argv[0]) == 0) {
+				/* we have an exact match */
+				count = 1;
+				break;
+			}
+			count++;
+		}
+		cmd++;
+	}
+
+	if (count > 1) {
+		printf("Ambiguous command '%s'; possible commands:", argv[0]);
+		cmd = wpa_commands;
+		while (cmd->cmd) {
+			if (strncasecmp(cmd->cmd, argv[0],
+					   strlen(argv[0])) == 0) {
+				printf(" %s", cmd->cmd);
+			}
+			cmd++;
+		}
+		printf("\n");
+		ret = 1;
+	} else if (count == 0) {
+		printf("Unknown command '%s'\n", argv[0]);
+		ret = 1;
+	} else {
+		ret = match->handler(ctrl, argc - 1, &argv[1]);
+	}
+
+	return ret;
+}
--- old/usr/src/lib/libnwam/common/libnwam_known_wlan.c	2012-06-12 19:55:06.662195821 +0200
+++ new/usr/src/lib/libnwam/common/libnwam_known_wlan.c	2012-06-12 19:55:06.686458927 +0200
@@ -530,7 +530,8 @@
 
 	if (secmode != DLADM_WLAN_SECMODE_NONE &&
 	    secmode != DLADM_WLAN_SECMODE_WEP &&
-	    secmode != DLADM_WLAN_SECMODE_WPA)
+	    secmode != DLADM_WLAN_SECMODE_PSK &&
+	    secmode != DLADM_WLAN_SECMODE_EAP)
 		return (NWAM_ENTITY_INVALID_VALUE);
 
 	return (NWAM_SUCCESS);
--- old/usr/src/lib/libnwam/common/libnwam_values.c	2012-06-12 19:55:07.875221212 +0200
+++ new/usr/src/lib/libnwam/common/libnwam_values.c	2012-06-12 19:55:07.898704255 +0200
@@ -723,7 +723,8 @@
 {
 	{ "none", DLADM_WLAN_SECMODE_NONE },
 	{ "wep", DLADM_WLAN_SECMODE_WEP },
-	{ "wpa", DLADM_WLAN_SECMODE_WPA },
+	{ "wpa-psk", DLADM_WLAN_SECMODE_PSK },
+	{ "wpa-eap", DLADM_WLAN_SECMODE_EAP },
 	{ NULL, 0 }
 };
 
--- old/usr/src/lib/libsecdb/help/auths/Makefile	2012-06-12 19:55:10.229711926 +0200
+++ new/usr/src/lib/libsecdb/help/auths/Makefile	2012-06-12 19:55:10.253523527 +0200
@@ -132,8 +132,6 @@
 	NetworkHeader.html \
 	NetworkVRRP.html \
 	NetworkInterfaceConfig.html \
-	WifiConfig.html \
-	WifiWep.html \
 	LinkSecurity.html \
 	IdmapRules.html \
 	SmfIdmapStates.html \
--- old/usr/src/pkg/manifests/SUNWcs.mf	2012-06-12 19:55:11.649250719 +0200
+++ new/usr/src/pkg/manifests/SUNWcs.mf	2012-06-12 19:55:11.680453973 +0200
@@ -1125,8 +1125,6 @@
 file path=usr/lib/help/auths/locale/C/SysShutdown.html
 file path=usr/lib/help/auths/locale/C/SysSyseventRead.html
 file path=usr/lib/help/auths/locale/C/SysSyseventWrite.html
-file path=usr/lib/help/auths/locale/C/WifiConfig.html
-file path=usr/lib/help/auths/locale/C/WifiWep.html
 file path=usr/lib/help/auths/locale/C/ZoneCloneFrom.html
 file path=usr/lib/help/auths/locale/C/ZoneHeader.html
 file path=usr/lib/help/auths/locale/C/ZoneLogin.html
--- old/usr/src/pkg/manifests/consolidation-osnet-osnet-message-files.mf	2012-06-12 19:55:13.759803100 +0200
+++ new/usr/src/pkg/manifests/consolidation-osnet-osnet-message-files.mf	2012-06-12 19:55:13.784044219 +0200
@@ -210,8 +210,6 @@
 file path=usr/lib/help/auths/locale/TNDaemon.html
 file path=usr/lib/help/auths/locale/TNctl.html
 file path=usr/lib/help/auths/locale/ValueTND.html
-file path=usr/lib/help/auths/locale/WifiConfig.html
-file path=usr/lib/help/auths/locale/WifiWep.html
 file path=usr/lib/help/auths/locale/ZoneCloneFrom.html
 file path=usr/lib/help/auths/locale/ZoneHeader.html
 file path=usr/lib/help/auths/locale/ZoneLogin.html
--- /dev/null	2012-06-12 19:55:14.000000000 +0200
+++ new/usr/src/pkg/manifests/service-network-wpa_supplicant.mf	2012-06-12 19:55:14.876707387 +0200
@@ -0,0 +1,58 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+#
+
+set name=pkg.fmri value=pkg:/service/network/wpa_supplicant@$(PKGVERS)
+set name=pkg.description \
+    value="The service implements the IEEE802.11i (WPA/WPA2) specification."
+set name=pkg.summary value="Wireless WPA Supplicant"
+set name=info.classification \
+    value=org.opensolaris.category.2008:System/Hardware
+set name=variant.arch value=$(ARCH)
+dir path=lib
+dir path=lib/svc
+dir path=lib/svc/manifest group=sys
+dir path=lib/svc/manifest/network group=sys
+dir path=usr group=sys
+dir path=usr/lib
+dir path=usr/lib/inet
+dir path=usr/share/man/man1m
+file path=lib/svc/manifest/network/wpa_supplicant.xml group=sys mode=0444
+file path=usr/lib/inet/wpa_supplicant mode=0555
+file path=usr/share/man/man1m/wpa_supplicant.1m
+legacy pkg=SUNWwpar \
+    desc="The service implements the IEEE802.11i (WPA/WPA2) specification." \
+    name="Wireless WPA Supplicant, (Root)"
+legacy pkg=SUNWwpau \
+    desc="The service implements the IEEE802.11i (WPA/WPA2) specification." \
+    name="Wireless WPA Supplicant, (Usr)"
+license cr_Sun license=cr_Sun
+license lic_CDDL license=lic_CDDL
+license usr/src/cmd/cmd-inet/usr.lib/wpa_supplicant/THIRDPARTYLICENSE \
+    license=usr/src/cmd/cmd-inet/usr.lib/wpa_supplicant/THIRDPARTYLICENSE
+depend fmri=SUNWcs type=require
+depend fmri=SUNWcsd type=require
+depend fmri=system/library type=require
+depend fmri=system/library/platform type=require
+depend fmri=system/library/processor type=require
--- old/usr/src/uts/common/inet/wifi_ioctl.h	2012-06-12 19:55:15.138277698 +0200
+++ new/usr/src/uts/common/inet/wifi_ioctl.h	2012-06-12 19:55:15.162065841 +0200
@@ -25,6 +25,7 @@
 
 /*
  * Macro and date structures defined for 802.11 wifi config tool.
+ * (no more used, we should remove them)
  */
 
 #ifndef	__WIFI_IOCTL_H
@@ -37,8 +38,6 @@
 #endif
 
 #define	MAX_KEY_LENGTH 26
-#define	MAX_ESSID_LENGTH (32 + 1)	/* max essid length is 32 */
-					/* one more for '\0' */
 #define	MAX_CHANNEL_NUM	99
 #define	MAX_RSSI 15
 #define	MAX_NWEPKEYS 4
@@ -49,6 +48,7 @@
 /*
  * ioctls
  */
+
 #define	WLAN_IOCTL_BASE 0x1000
 #define	WLAN_GET_VERSION (WLAN_IOCTL_BASE + 0x0)
 #define	WLAN_SET_PARAM (WLAN_IOCTL_BASE + 0x2)
@@ -58,6 +58,7 @@
 /*
  * parameters
  */
+
 #define	WL_PARAMETERS_BASE 0x2000
 #define	WL_BSSID (WL_PARAMETERS_BASE + 0x0)
 #define	WL_ESSID (WL_PARAMETERS_BASE + 0x1)
@@ -97,6 +98,7 @@
 #define	WL_RADIO (WL_PARAMETERS_BASE + 0x23)
 #define	WL_LINKSTATUS (WL_PARAMETERS_BASE + 0x24)
 #define	WL_DEV_DEPEND (WL_PARAMETERS_BASE + 0x25)
+
 /*
  * commands
  */
@@ -109,6 +111,7 @@
 
 /*
  * domains
+ * outdated?
  */
 /* --USA */
 #define	WL_DOMAIN_BASE 0x4000
@@ -126,6 +129,7 @@
 
 /*
  * power mode
+ * not implemented
  */
 
 #define	WL_PM_AM 0x0
@@ -163,6 +167,7 @@
 #define	WL_NOENCRYPTION 0x0
 #define	WL_ENC_WEP 0x1
 #define	WL_ENC_WPA 0x2
+
 #define	WL_OPENSYSTEM 0x1
 #define	WL_SHAREDKEY 0x2
 
@@ -208,9 +213,10 @@
 #define	WL_HRDS (WL_OTHER_BASE + 0x4)
 #define	WL_ERP (WL_OTHER_BASE + 0x5)
 
-#define	WL_BSS_BSS 1
-#define	WL_BSS_IBSS 3
-#define	WL_BSS_ANY 2
+/* aligned with wpa_s values */
+#define	WL_BSS_BSS 0
+#define	WL_BSS_IBSS 1
+#define	WL_BSS_AP 2
 /*
  * field_offset
  */
@@ -220,16 +226,17 @@
  * type definationes
  */
 typedef boolean_t wl_create_ibss_t;
-typedef char wl_bssid_t[6];
+typedef uint8_t wl_bssid_t[6];
 
 typedef struct wl_essid {
 	uint32_t wl_essid_length;
-	char wl_essid_essid[34];
-}wl_essid_t;
+	uint8_t wl_essid_essid[32];
+} wl_essid_t;
 
+/* there are no consumers for wl_nodename prop */
 typedef struct wl_nodename {
 	uint32_t wl_nodename_length;
-	char wl_nodename_name[34];
+	char wl_nodename_name[32];
 } wl_nodename_t;
 
 typedef struct wl_phy_supported {
@@ -302,14 +309,16 @@
 typedef uint32_t wl_rssi_t;
 typedef uint32_t wl_rssi_threshold_t;
 typedef uint32_t wl_bss_type_t;
-typedef uint32_t wl_authmode_t;
+typedef uint8_t wl_authmode_t;
 typedef uint32_t wl_encryption_t;
 typedef uint32_t wl_wep_key_id_t;
 typedef boolean_t wl_radio_t;
 typedef uint32_t wl_rts_threshold_t;
 typedef uint32_t wl_short_retry_t;
 typedef uint32_t wl_long_retry_t;
-typedef uint32_t wl_beacon_period_t;
+typedef uint16_t wl_beacon_period_t;
+typedef uint32_t wl_beacon_age_t;
+typedef uint64_t wl_beacon_tsf_t;
 typedef uint32_t wl_tx_lifetime_t;
 typedef uint32_t wl_rx_lifetime_t;
 typedef uint32_t wl_frag_threshold_t;
@@ -324,23 +333,93 @@
 	char wl_rates_rates[1];
 } wl_rates_t;
 
+/*
+ * Macro and data structures defined for 802.11i.
+ */
+
+typedef struct wl_wpa_ie {
+	uint32_t	wpa_ie_len;
+	uint8_t		wpa_ie[1];	/* it's the head of wpa_ie */
+} wl_wpa_ie_t;
+
+typedef struct wl_wpa {
+	uint32_t	wpa_flag;
+} wl_wpa_t;
+
+typedef struct wl_capability {
+	uint32_t	caps;
+} wl_capability_t;
+
+typedef uint16_t wl_ess_caps;
+
+/*
+ * WPA/RSN get/set key request.
+ * ik_type  : wep/tkip/aes
+ * ik_keyix : should be between 0 and 3, 0 will be used as default key.
+ * ik_keylen: key length in bytes.
+ * ik_keydata and ik_keylen include the DATA key and MIC key.
+ * ik_keyrsc/ik_keytsc: rx/tx seq number.
+ */
+#pragma pack(1)
+typedef struct wl_key {
+	uint8_t		ik_type;
+	uint8_t		ik_pad;
+
+	uint16_t	ik_keyix;
+	uint8_t		ik_keylen;
+	uint8_t		ik_flags;
+
+	uint8_t		ik_macaddr[6];
+	uint64_t	ik_keyrsc;
+	uint64_t	ik_keytsc;
+
+	/* [IEEE80211_KEYBUF_SIZE+IEEE80211_MICBUF_SIZE] */
+	uint8_t		ik_keydata[32];
+} wl_key_t;
+#pragma pack()
+
+typedef struct wl_del_key {
+	uint8_t		idk_keyix;
+	uint8_t		idk_macaddr[6];
+} wl_del_key_t;
+
+/*
+ * structure for WL_MLME state manipulation request.
+ * im_op: operations include auth/deauth/assoc/disassoc,
+ * im_reason: 802.11 reason code
+ */
+typedef struct wl_mlme {
+	uint8_t		im_op;
+	uint16_t	im_reason;
+	uint8_t		im_macaddr[6];
+} wl_mlme_t;
+
+/*
+ * beacon, probe response
+ */
+
+#pragma pack(1)
 typedef struct wl_ess_conf {
-	uint32_t wl_ess_conf_length;
-	wl_essid_t wl_ess_conf_essid;
-	wl_bssid_t wl_ess_conf_bssid;
-	char wl_ess_conf_reserved[2];
-	wl_bss_type_t wl_ess_conf_bsstype;
-	wl_authmode_t wl_ess_conf_authmode;
-	boolean_t wl_ess_conf_wepenabled;
-	wl_rssi_t wl_ess_conf_sl;
+	uint32_t 		wl_ess_conf_length;
+	wl_essid_t 		wl_ess_conf_essid;
+	wl_bssid_t 		wl_ess_conf_bssid;
+	wl_beacon_period_t	wl_ess_conf_beacon_period;
+	wl_beacon_tsf_t		wl_ess_conf_beacon_tsf;
+	wl_beacon_age_t		wl_ess_conf_beacon_age;
+	wl_rssi_t 		wl_ess_conf_sl;
+	char 			wl_supported_rates[MAX_SCAN_SUPPORT_RATES];
 	union {
-		wl_fhss_t wl_phy_fhss_conf;
-		wl_dsss_t wl_phy_dsss_conf;
-		wl_ofdm_t wl_phy_ofdm_conf;
-		wl_erp_t wl_phy_erp_conf;
+		wl_fhss_t 	wl_phy_fhss_conf;
+		wl_dsss_t 	wl_phy_dsss_conf;
+		wl_ofdm_t 	wl_phy_ofdm_conf;
+		wl_erp_t 	wl_phy_erp_conf;
 	} wl_phy_conf;
-	char wl_supported_rates[MAX_SCAN_SUPPORT_RATES];
+	/* ieee80211_node capinfo != ieee80211com caps */
+	wl_ess_caps 		wl_ess_conf_caps;
+	uint32_t		wl_ess_conf_wpa_ie_len;
+	uint8_t			wl_ess_conf_wpa_ie[40];
 } wl_ess_conf_t;
+#pragma pack()
 
 typedef struct wl_ess_list {
 	uint32_t wl_ess_list_num;
